diff --git a/lisp/faces.el b/lisp/faces.el
index 18b821a..614205b 100644
--- a/lisp/faces.el
+++ b/lisp/faces.el
@@ -2502,6 +2502,33 @@ unwanted effects."
   :group 'basic-faces
   :group 'display-line-numbers)
 
+
+;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+;;; Multiple Cursors
+
+(defface +-vertical-bar-face
+  '((t (:foreground "cyan")))
+  "Face for `+-vertical-bar-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-even-numbered-column-face
+  '((t (:foreground "yellow")))
+  "Face for `+-even-numbered-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-odd-numbered-column-face
+  '((t (:foreground "red")))
+  "Face for `+-odd-numbered-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-beyond-fill-column-face
+  '((t (:foreground "green")))
+  "Face for `+-beyond-fill-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+
+
 (defface escape-glyph
   '((((background dark)) :foreground "cyan")
     ;; See the comment in minibuffer-prompt for
diff --git a/src/buffer.c b/src/buffer.c
index 244c185..17cfcb0 100644
--- a/src/buffer.c
+++ b/src/buffer.c
@@ -5119,6 +5119,20 @@ init_buffer_once (void)
   bset_last_selected_window (&buffer_local_flags, make_number (0));
 
   idx = 1;
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_glyph_list), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs_horizontal_ruler), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs_vertical_ruler), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_stderr), idx); ++idx;
+
+/* *************************************************************************** */
+
+
   XSETFASTINT (BVAR (&buffer_local_flags, mode_line_format), idx); ++idx;
   XSETFASTINT (BVAR (&buffer_local_flags, abbrev_mode), idx); ++idx;
   XSETFASTINT (BVAR (&buffer_local_flags, overwrite_mode), idx); ++idx;
@@ -5200,6 +5214,20 @@ init_buffer_once (void)
   /* Must do these before making the first buffer! */
 
   /* real setup is done in bindings.el */
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  bset_blv_mc_glyph_list (&buffer_defaults, Qnil);
+  bset_blv_crosshairs (&buffer_defaults, Qnil);
+  bset_blv_crosshairs_horizontal_ruler (&buffer_defaults, Qt);
+  bset_blv_crosshairs_vertical_ruler (&buffer_defaults, Qt);
+  bset_blv_mc_stderr (&buffer_defaults, Qnil);
+
+/* *************************************************************************** */
+
+
   bset_mode_line_format (&buffer_defaults, build_pure_c_string ("%-"));
   bset_header_line_format (&buffer_defaults, Qnil);
   bset_abbrev_mode (&buffer_defaults, Qnil);
@@ -5448,6 +5476,19 @@ syms_of_buffer (void)
   staticpro (&QSFundamental);
   staticpro (&Vbuffer_alist);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  DEFSYM (Qmc_glyph_list, "mc-glyph-list");
+  DEFSYM (Qcrosshairs, "crosshairs");
+  DEFSYM (Qcrosshairs_horizontal_ruler, "crosshairs-horizontal-ruler");
+  DEFSYM (Qcrosshairs_vertical_ruler, "crosshairs-vertical-ruler");
+  DEFSYM (Qmc_stderr, "mc-stderr");
+
+/* *************************************************************************** */
+
+
   DEFSYM (Qchoice, "choice");
   DEFSYM (Qleft, "left");
   DEFSYM (Qright, "right");
@@ -5485,6 +5526,29 @@ syms_of_buffer (void)
   Fput (Qprotected_field, Qerror_message,
 	build_pure_c_string ("Attempt to modify a protected field"));
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  DEFVAR_PER_BUFFER ("mc-glyph-list", &BVAR (current_buffer, mc_glyph_list), Qnil,
+    doc: /* A bufer-local variable to store the value of the multiple cursors to be displayed
+during the next redisplay. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs", &BVAR (current_buffer, crosshairs), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate crosshairs. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs-horizontal-ruler", &BVAR (current_buffer, crosshairs_horizontal_ruler), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate the crosshairs horizontal ruler. */);
+
+  DEFVAR_PER_BUFFER ("crosshairs-vertical-ruler", &BVAR (current_buffer, crosshairs_vertical_ruler), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate the crosshairs vertical ruler. */);
+
+  DEFVAR_PER_BUFFER ("mc-stderr", &BVAR (current_buffer, mc_stderr), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate debugging messages to stderr. */);
+
+/* *************************************************************************** */
+
+
   DEFVAR_PER_BUFFER ("header-line-format",
 		     &BVAR (current_buffer, header_line_format),
 		     Qnil,
diff --git a/src/buffer.h b/src/buffer.h
index 85b5631..7e03be4 100644
--- a/src/buffer.h
+++ b/src/buffer.h
@@ -658,6 +658,28 @@ struct buffer
      cache are enabled.  See search.c, indent.c and bidi.c for details.  */
   Lisp_Object cache_long_scans_;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  /* The name of list used by multiple cursors for next redisplay. */
+  Lisp_Object mc_glyph_list_;
+
+  /* The name of list. */
+  Lisp_Object crosshairs_;
+
+  /* The name of the crosshairs horizontal ruler. */
+  Lisp_Object crosshairs_horizontal_ruler_;
+
+  /* The name of the crosshairs vertical ruler. */
+  Lisp_Object crosshairs_vertical_ruler_;
+
+  /* Used in conjunction with generating stderr debugging message. */
+  Lisp_Object mc_stderr_;
+
+/* *************************************************************************** */
+
+
   /* If the width run cache is enabled, this table contains the
      character widths width_run_cache (see above) assumes.  When we
      do a thorough redisplay, we compare this against the buffer's
@@ -918,6 +940,44 @@ XBUFFER (Lisp_Object a)
 /* Most code should use these functions to set Lisp fields in struct
    buffer.  (Some setters that are private to a single .c file are
    defined as static in those files.)  */
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+INLINE void
+bset_blv_mc_glyph_list (struct buffer *b, Lisp_Object val)
+{
+  b->mc_glyph_list_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs_horizontal_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_horizontal_ruler_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs_vertical_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_vertical_ruler_ = val;
+}
+
+INLINE void
+bset_blv_mc_stderr (struct buffer *b, Lisp_Object val)
+{
+  b->mc_stderr_ = val;
+}
+
+/* *************************************************************************** */
+
+
 INLINE void
 bset_bidi_paragraph_direction (struct buffer *b, Lisp_Object val)
 {
diff --git a/src/dispextern.h b/src/dispextern.h
index 2180c9a..f0b10c5 100644
--- a/src/dispextern.h
+++ b/src/dispextern.h
@@ -3284,6 +3284,30 @@ extern void get_font_ascent_descent (struct font *, int *, int *);
 
 #ifdef HAVE_WINDOW_SYSTEM
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+enum mc_glyph_flavor
+{
+  NO_FLAVOR,
+  MC_GLYPH,
+  MC_GLYPHLESS,
+  MC_GLYPH_TAB,
+  OVERLAY_ARROW_BITMAP,
+  MC_PILCROW,
+  MC_HOLLOW_RECTANGLE_RIGHT_ANGLE,
+  MC_HOLLOW_RECTANGLE,
+  MC_VERTICAL_BAR_RIGHT_ANGLE,
+  MC_VERTICAL_BAR,
+  MC_VERTICAL_BAR_BACKSLASH
+};
+
+void mc_portal (struct window *, bool);
+
+/* *************************************************************************** */
+
+
 #ifdef GLYPH_DEBUG
 extern void dump_glyph_string (struct glyph_string *) EXTERNALLY_VISIBLE;
 #endif
diff --git a/src/fringe.c b/src/fringe.c
index 6069184..66d0187 100644
--- a/src/fringe.c
+++ b/src/fringe.c
@@ -433,6 +433,231 @@ static unsigned short empty_line_bits[] = {
   0x00, 0x3c, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x3c, 0x00};
 
 
+/* *************************************************************************** */
+/* begin MULTIPLE CURSORS */
+
+/*  ;; AUTHOR:  Nikolaj Schumacher -- https://github.com/nschum/fringe-helper.el
+    (defun +-fringe-helper-hexadecimal (&rest strings)
+    "Convert STRINGS into a vector usable for `define-fringe-bitmap'.
+    Each string in STRINGS represents a line of the fringe bitmap.
+    Periods (.) are background-colored pixel; Xs are foreground-colored. The
+    fringe bitmap always is aligned to the right. If the fringe has half
+    width, only the left 4 pixels of an 8 pixel bitmap will be shown.
+    For example, the following code defines a diagonal line.
+    \(+-fringe-helper-hexadecimal
+    \"XX......\"
+    \"..XX....\"
+    \"....XX..\"
+    \"......XX\"\)"
+      (unless (cdr strings)
+        (setq strings (split-string (car strings) "\n")))
+      (apply 'vector
+        (mapcar
+          (lambda (str)
+            (let ((num 0))
+              (dolist (c (string-to-list str))
+                (setq num (+ (* num 2) (if (eq c ?.) 0 1))))
+              (format "%#-x" num)))
+          strings)))
+*/
+
+/* 24
+    (+-fringe-helper-hexadecimal
+      "x......."
+      "x......."
+      "x......."
+      "x..xx..."
+      "x...xx.."
+      "x....xx."
+      "x.xxxxxx"
+      "x.xxxxxx"
+      "x....xx."
+      "x...xx.."
+      "x..xx..."
+      "x......."
+      "x......."
+      "x.......")
+*/
+static unsigned short mc_vertical_bar_right_angle_bits[] ={
+  0x80, 0x80, 0x80, 0x98, 0x8c, 0x86, 0xbf,
+  0xbf, 0x86, 0x8c, 0x98, 0x80, 0x80, 0x80};
+
+/* 25
+    (+-fringe-helper-hexadecimal
+      "xxxxxxxx"
+      "x......x"
+      "x......x"
+      "x..xx..x"
+      "x...xx.x"
+      "x....xxx"
+      "x.xxxxxx"
+      "x.xxxxxx"
+      "x....xxx"
+      "x...xx.x"
+      "x..xx..x"
+      "x......x"
+      "x......x"
+      "xxxxxxxx")
+*/
+static unsigned short mc_hollow_rectangle_right_angle_bits[] ={
+  0xff, 0x81, 0x81, 0x99, 0x8d, 0x87, 0xbf,
+  0xbf, 0x87, 0x8d, 0x99, 0x81, 0x81, 0xff};
+
+/* 26
+    (+-fringe-helper-hexadecimal
+      "xxxxxxxx"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "xxxxxxxx")
+*/
+static unsigned short mc_hollow_rectangle_bits[] ={
+  0xff, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81,
+  0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xff};
+
+/* 27
+    (+-fringe-helper-hexadecimal
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x.......")
+*/
+static unsigned short mc_vertical_bar_bits[] ={
+  0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
+  0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80};
+
+/* 28
+    (+-fringe-helper-hexadecimal
+      "xx......"
+      ".xx....."
+      "..xx...."
+      "...xx..."
+      "....xx.."
+      ".....xx."
+      "......xx"
+      ".....xx."
+      "....xx.."
+      "...xx..."
+      "..xx...."
+      ".xx....."
+      "xx......")
+*/
+static unsigned short mc_right_angle_bits[] ={
+  0xc0, 0x60, 0x30, 0x18, 0xc, 0x6, 0x3, 0x6, 0xc, 0x18, 0x30, 0x60, 0xc0};
+
+/* 29
+    (+-fringe-helper-hexadecimal
+      "xx......"
+      "xx......"
+      " xx....."
+      ".xx....."
+      "..xx...."
+      "..xx...."
+      "...xx..."
+      "...xx..."
+      "....xx.."
+      "....xx.."
+      ".....xx."
+      ".....xx."
+      "......xx"
+      "......xx")
+*/
+static unsigned short mc_backslash_bits[] ={
+  0xc0, 0xc0, 0xe0, 0x60, 0x30, 0x30, 0x18, 0x18, 0xc, 0xc, 0x6, 0x6, 0x3, 0x3};
+
+/* 30
+    (+-fringe-helper-hexadecimal
+      "xx......"
+      "xx......"
+      "xxx....."
+      "xxx....."
+      "x.xx...."
+      "x.xx...."
+      "x..xx..."
+      "x..xx..."
+      "x...xx.."
+      "x...xx.."
+      "x....xx."
+      "x....xx."
+      "x.....xx"
+      "x.....xx")
+*/
+static unsigned short mc_vertical_bar_backslash_bits[] ={
+  0xc0, 0xc0, 0xe0, 0xe0, 0xb0, 0xb0, 0x98,
+  0x98, 0x8c, 0x8c, 0x86, 0x86, 0x83, 0x83};
+
+/* 31
+    (+-fringe-helper-hexadecimal
+      ".xxxxxx."
+      "xxxx.x.."
+      "xxxx.x.."
+      "xxxx.x.."
+      ".xxx.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x..")
+*/
+static unsigned short mc_pilcrow_bits[] ={
+  0x7e, 0xf4, 0xf4, 0xf4, 0x74, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14};
+
+/* 32
+    (+-fringe-helper-hexadecimal
+      "xx.xx..."
+      ".xx.xx.."
+      "..xx.xx."
+      "...xx.xx"
+      "..xx.xx."
+      ".xx.xx.."
+      "xx.xx...")
+*/
+static unsigned short mc_right_double_angle_bits[] ={
+  0xd8, 0x6c, 0x36, 0x1b, 0x36, 0x6c, 0xd8};
+
+/* 33
+    (+-fringe-helper-hexadecimal
+      "..xxxx.."
+      ".xxxxxx."
+      "x..xx..x"
+      "x..xx..x"
+      "xxxxxxxx"
+      "xx....xx"
+      "xxx..xxx"
+      ".xxxxxx."
+      "..xxxx..")
+*/
+static unsigned short mc_smiley_face_bits[] ={
+  0x3c, 0x7e, 0x99, 0x99, 0xff, 0xc3, 0xe7, 0x7e, 0x3c};
+
+/* Add the following bitmaps:
+  (define-fringe-bitmap 'breakpoint "\x3c\x7e\xff\xff\xff\xff\x7e\x3c")
+  (define-fringe-bitmap 'hollow-right-triangle "\xe0\x90\x88\x84\x84\x88\x90\xe0") */
+
+/* end MULTIPLE CURSORS */
+/* *************************************************************************** */
+
+
 #define BYTES_PER_BITMAP_ROW  (sizeof (unsigned short))
 #define STANDARD_BITMAP_HEIGHT(bits) (sizeof (bits)/BYTES_PER_BITMAP_ROW)
 #define FRBITS(bits)  bits, STANDARD_BITMAP_HEIGHT (bits)
@@ -466,6 +691,35 @@ static struct fringe_bitmap standard_bitmaps[] =
   { FRBITS (vertical_bar_bits),       8, 0, ALIGN_BITMAP_CENTER, 0 },
   { FRBITS (horizontal_bar_bits),     8, 0, ALIGN_BITMAP_BOTTOM, 0 },
   { FRBITS (empty_line_bits),         8, 3, ALIGN_BITMAP_TOP,    0 },
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  /* 24 */
+  { FRBITS (mc_vertical_bar_right_angle_bits),     8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 25 */
+  { FRBITS (mc_hollow_rectangle_right_angle_bits), 8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 26 */
+  { FRBITS (mc_hollow_rectangle_bits),             8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 27 */
+  { FRBITS (mc_vertical_bar_bits),                 8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 28 */
+  { FRBITS (mc_right_angle_bits),                  8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 29 */
+  { FRBITS (mc_backslash_bits),                    8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 30 */
+  { FRBITS (mc_vertical_bar_backslash_bits),       8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 31 */
+  { FRBITS (mc_pilcrow_bits),                      8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 32 */
+  { FRBITS (mc_right_double_angle_bits),           8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 33 */
+  { FRBITS (mc_smiley_face_bits),                  8, 0, ALIGN_BITMAP_CENTER, 0 },
+
+/* *************************************************************************** */
+
+
 };
 
 #define NO_FRINGE_BITMAP 0
@@ -1715,6 +1969,77 @@ If nil, also continue lines which are exactly as wide as the window.  */);
   DEFVAR_LISP ("fringe-bitmaps", Vfringe_bitmaps,
     doc: /* List of fringe bitmap symbols.  */);
   Vfringe_bitmaps = Qnil;
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  /* (get 'empty-line 'fringe) => 23 => the last standard-bitmap before this one.
+  See `fringe.el`. */
+
+  /* 24 */
+  DEFSYM (Qmc_vertical_bar_right_angle, "+-vertical-bar-right-angle");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar_right_angle, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar_right_angle, Qfringe, make_number (24));
+  /* (get '+-vertical-bar-right-angle 'fringe) => 24 */
+
+  /* 25 */
+  DEFSYM (Qmc_hollow_rectangle_right_angle, "+-hollow-rectangle-right-angle");
+  Vfringe_bitmaps = Fcons (Qmc_hollow_rectangle_right_angle, Vfringe_bitmaps);
+  Fput (Qmc_hollow_rectangle_right_angle, Qfringe, make_number (25));
+  /* (get '+-hollow-rectangle-right-angle 'fringe) => 25 */
+
+  /* 26 */
+  DEFSYM (Qmc_hollow_rectangle, "+-hollow-rectangle");
+  Vfringe_bitmaps = Fcons (Qmc_hollow_rectangle, Vfringe_bitmaps);
+  Fput (Qmc_hollow_rectangle, Qfringe, make_number (26));
+  /* (get '+-hollow-rectangle 'fringe) => 26 */
+
+  /* 27 */
+  DEFSYM (Qmc_vertical_bar, "+-vertical-bar");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar, Qfringe, make_number (27));
+  /* (get '+-vertical-bar 'fringe) => 27 */
+
+  /* 28 */
+  DEFSYM (Qmc_right_angle, "+-right-angle");
+  Vfringe_bitmaps = Fcons (Qmc_right_angle, Vfringe_bitmaps);
+  Fput (Qmc_right_angle, Qfringe, make_number (28));
+  /* (get '+-right-angle 'fringe) => 28 */
+
+  /* 29 */
+  DEFSYM (Qmc_backslash, "+-backslash");
+  Vfringe_bitmaps = Fcons (Qmc_backslash, Vfringe_bitmaps);
+  Fput (Qmc_backslash, Qfringe, make_number (29));
+  /* (get '+-backslash 'fringe) => 29 */
+
+  /* 30 */
+  DEFSYM (Qmc_vertical_bar_backslash, "+-vertical-bar-backslash");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar_backslash, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar_backslash, Qfringe, make_number (30));
+  /* (get '+-vertical-bar-backslash 'fringe) => 30 */
+
+  /* 31 */
+  DEFSYM (Qmc_pilcrow, "+-pilcrow");
+  Vfringe_bitmaps = Fcons (Qmc_pilcrow, Vfringe_bitmaps);
+  Fput (Qmc_pilcrow, Qfringe, make_number (31));
+  /* (get '+-pilcrow 'fringe) => 31 */
+
+  /* 32 */
+  DEFSYM (Qmc_right_double_angle, "+-right-double-angle");
+  Vfringe_bitmaps = Fcons (Qmc_right_double_angle, Vfringe_bitmaps);
+  Fput (Qmc_right_double_angle, Qfringe, make_number (32));
+  /* (get '+-right-double-angle 'fringe) => 32 */
+
+  /* 33 */
+  DEFSYM (Qmc_smiley_face, "+-smiley-face");
+  Vfringe_bitmaps = Fcons (Qmc_smiley_face, Vfringe_bitmaps);
+  Fput (Qmc_smiley_face, Qfringe, make_number (33));
+  /* (get '+-smiley-face 'fringe) => 33 */
+
+/* *************************************************************************** */
+
+
 }
 
 /* Garbage collection hook */
diff --git a/src/keyboard.c b/src/keyboard.c
index aa58e26..8fd3ac8 100644
--- a/src/keyboard.c
+++ b/src/keyboard.c
@@ -1224,6 +1224,29 @@ static int read_key_sequence (Lisp_Object *, Lisp_Object,
                               bool, bool, bool, bool);
 static void adjust_point_for_property (ptrdiff_t, bool);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+static void
+kbd_mc_activate_cursors (void)
+{
+  struct window *w = decode_live_window (selected_window);
+  w->mc.draw_glyph_cursor = true;
+  w->mc.erase_glyph_cursor = true;
+}
+
+static void
+kbd_mc_activate_crosshairs (void)
+{
+  struct window *w = decode_live_window (selected_window);
+  w->mc.draw_crosshairs = true;
+  w->mc.erase_crosshairs = true;
+}
+
+/* *************************************************************************** */
+
+
 Lisp_Object
 command_loop_1 (void)
 {
@@ -1419,6 +1442,15 @@ command_loop_1 (void)
       Vreal_this_command = cmd;
       safe_run_hooks (Qpre_command_hook);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      kbd_mc_activate_cursors ();
+
+/* *************************************************************************** */
+
+
       already_adjusted = 0;
 
       if (NILP (Vthis_command))
diff --git a/src/nsterm.m b/src/nsterm.m
index a15684d..2602920 100644
--- a/src/nsterm.m
+++ b/src/nsterm.m
@@ -1188,10 +1188,14 @@ static NSRect constrain_frame_rect(NSRect frameRect, bool isFullscreen)
     {
       block_input ();
 
-      if (cursor_on_p)
-	display_and_set_cursor (w, 1,
-				w->output_cursor.hpos, w->output_cursor.vpos,
-				w->output_cursor.x, w->output_cursor.y);
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      mc_portal (w, cursor_on_p);
+
+/* *************************************************************************** */
+
 
       if (draw_window_fringes (w, 1))
 	{
@@ -3206,8 +3210,29 @@ Note that CURSOR_WIDTH is meaningful only for (h)bar cursors.
 
   if ((phys_cursor_glyph = get_phys_cursor_glyph (w)) == NULL)
     {
-      if (glyph_row->exact_window_width_line_p
-          && w->phys_cursor.hpos >= glyph_row->used[TEXT_AREA])
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      /* This modification enables placement of the cursor-in-fringe bitmap when
+      the window-width is slightly less than `glyph_row->exact_window_width_line_p`.
+      This modification also prevents drawing the real cursor on the fringe (instead
+      of using the cursor-in-fringe bitmap) in the above-mentioned circumstance.
+      See the following related patches:
+      -  July 19, 2016:  bf5ddded70c11edaf3514b25da27fc71cfb8e965
+      -  May 21, 2016:  e5015c5d9632a0bf685c093249ae4a7d3e825b13
+      See the following bug reports:  #16856 and #29233. */
+      int frame_char_width = FRAME_COLUMN_WIDTH (f);
+      int text_area_width = window_box_width (w, TEXT_AREA);
+      bool cursor_in_fringe_p = w->phys_cursor.x + frame_char_width >= text_area_width;
+      if ((glyph_row->exact_window_width_line_p
+            && w->phys_cursor.hpos >= glyph_row->used[TEXT_AREA])
+          || cursor_in_fringe_p)
+
+/* *************************************************************************** */
+
+
         {
           glyph_row->cursor_in_fringe_p = 1;
           draw_fringe_bitmap (w, glyph_row, 0);
@@ -3243,17 +3268,68 @@ Note that CURSOR_WIDTH is meaningful only for (h)bar cursors.
       h = cursor_height;
     }
 
-  r.origin.x = fx, r.origin.y = fy;
-  r.size.height = h;
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  r.origin.x = (w->mc.fx > 0)
+               ? w->mc.fx
+               : fx;
+  r.origin.y = (w->mc.fy > 0)
+               ? w->mc.fy
+               : fy;
+  r.size.height = (w->mc.h > 0)
+                  ? w->mc.h
+                  : h;
   r.size.width = w->phys_cursor_width;
 
+/* *************************************************************************** */
+
+
   /* Prevent the cursor from being drawn outside the text area.  */
   ns_clip_to_row (w, glyph_row, TEXT_AREA, NO); /* do ns_focus(f, &r, 1); if remove */
 
 
   face = FACE_FROM_ID_OR_NULL (f, phys_cursor_glyph->face_id);
-  if (face && NS_FACE_BACKGROUND (face)
-      == ns_index_color (FRAME_CURSOR_COLOR (f), f))
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* EXAMPLE OF HOW TO LOOK-UP A COLOR:
+  enum face_id face_id = lookup_named_face (f, intern ("+-vertical-bar-face"), true);
+  struct face *face = FACE_FROM_ID (f, face_id);
+  NSColor *color = ns_lookup_indexed_color (NS_FACE_FOREGROUND (face), f);
+*/
+
+  if (w->mc.glyph_flavor == MC_GLYPH
+      || w->mc.glyph_flavor == MC_GLYPHLESS
+      || w->mc.glyph_flavor == MC_GLYPH_TAB)
+    {
+      Lisp_Object buf = w->contents;
+      CHECK_BUFFER (buf);
+      struct buffer *b = XBUFFER (buf);
+      bool region_active_p = (!NILP (Vtransient_mark_mode)
+                              && !NILP (BVAR (b, mark_active)));
+      ptrdiff_t region_beginning = (region_active_p) ? XINT (Fregion_beginning ()) : -1;
+      ptrdiff_t region_end = (region_active_p) ? XINT (Fregion_end ()) : -1;
+      bool region_p = (region_active_p
+                       && PT >= region_beginning
+                       && PT < region_end);
+      [[NSColor colorWithCalibratedRed: w->mc.red green: w->mc.green blue: w->mc.blue alpha: 1.0] set];
+      if (region_p)
+        hollow_color = ns_lookup_indexed_color (NS_FACE_BACKGROUND (face), f);
+        else if (face && NS_FACE_BACKGROUND (face) == ns_index_color (FRAME_CURSOR_COLOR (f), f))
+          hollow_color = FRAME_CURSOR_COLOR (f);
+      /* FIXME:  Add a condition for `hollow_color` if the region foreground is the
+      same as the default background and choose an appropriate color if so. */
+    }
+  else if (face && NS_FACE_BACKGROUND (face)
+           == ns_index_color (FRAME_CURSOR_COLOR (f), f))
+
+/* *************************************************************************** */
+
+
     {
       [ns_lookup_indexed_color (NS_FACE_FOREGROUND (face), f) set];
       hollow_color = FRAME_CURSOR_COLOR (f);
@@ -3300,10 +3376,19 @@ Note that CURSOR_WIDTH is meaningful only for (h)bar cursors.
     }
   ns_unfocus (f);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
   /* draw the character under the cursor */
-  if (cursor_type != NO_CURSOR)
+  if (cursor_type != NO_CURSOR
+      && w->mc.glyph_flavor != MC_GLYPHLESS
+      && w->mc.glyph_flavor != MC_GLYPH_TAB)
     draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
 
+/* *************************************************************************** */
+
+
 #ifdef NS_IMPL_COCOA
   NSEnableScreenUpdates ();
 #endif
